package one.microstream.integrations.spring.boot.types.oracle;

/*-
 * #%L
 * microstream-spring
 * %%
 * Copyright (C) 2019 - 2021 MicroStream Software
 * %%
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 * 
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License, v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is
 * available at https://www.gnu.org/software/classpath/license.html.
 * 
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 * #L%
 */

import one.microstream.integrations.spring.boot.types.oracle.coherence.Coherence;
import one.microstream.integrations.spring.boot.types.oracle.nosql.Nosql;
import org.springframework.boot.context.properties.NestedConfigurationProperty;

public class Oracle
{

    @NestedConfigurationProperty
    private Coherence coherence;

    @NestedConfigurationProperty
    private Nosql nosql;

    public Coherence getCoherence()
    {
        return coherence;
    }

    public void setCoherence(Coherence coherence)
    {
        this.coherence = coherence;
    }

    public Nosql getNosql()
    {
        return nosql;
    }

    public void setNosql(Nosql nosql)
    {
        this.nosql = nosql;
    }
}
